/*
    test Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "device/dr16.h"
#include "cmsis_os2.h"
#include "module/chassis.h"
#include "module/config.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
Chassis_t chassis;
Chassis_CMD_t chassis_cmd;         // 控制命令
Chassis_IMU_t chassis_imu;
static AHRS_Eulr_t mech_zero = {0};      // 机械零位（初始 yaw）
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_test(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / TEST_FREQ;

  osDelay(TEST_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
 /* === 初始化底盘 === */
    Config_RobotParam_t *cfg = Config_GetRobotParam();
    Chassis_Init(&chassis, &cfg->chassis_param, (float)TEST_FREQ);
    chassis.mech_zero=4.13f;

  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */

				//osMessageQueueGet(task_runtime.msgq.chassis.yaw, &chassis.feedback.encoder_gimbalYawMotor, NULL, 0);从yaw电机反馈得到值
				//osMessageQueueGet(task_runtime.msgq.chassis.cmd, &chassis_cmd, NULL, 0);//遥控器
							/* 3) 更新反馈 → 控制 → 输出 */
        Chassis_UpdateFeedback(&chassis);
        Chassis_Control(&chassis, &chassis_cmd, osKernelGetTickCount());
        Chassis_Output(&chassis);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}

